% extract information from swiss data file
% edit the flat,flong conditions to select region

fid = fopen('f:/ELV3S.DTM','r');
mapref = fscanf(fid,'%f',6)
lat = mapref(1):mapref(5):mapref(2);
long = mapref(3):mapref(6):mapref(4);
fulldim = [length(lat) length(long)];
longdim = length(long);

flat = find(lat >= 46 & lat <= 47);
flong = find(long >= 7 & long <= 9);
outputdim = [length(flat) length(flong)];

for i = 1:min(flat)-1 % skip over unwanted columns
    junk = fscanf(fid,'%f',9600);
end

disp('Unwanted columns read; properties of the last row should give [1 1 1]');

plot(junk) % check that plot looks good
[max(junk-floor(junk))==0 % make sure data is integer
max(junk)< 2^15 % make sure data fits in 16 bits
min(junk) >= 0]' % make sure all elevations are positive

j = 1;
m = zeros(outputdim,'uint16');
for i = flat
    junk = fscanf(fid,'%f',longdim);
    m(j,:) = int16(junk(flong)');
    j = j+1;
end
fclose(fid)

switzelev = flipud(m); % elevation data has origin at top 
switzelev_ref = [mapref(2) mapref(3) mapref(5)];
disp('matrix read as switzelev')

worldmap(double(switzelev), switzelev_ref, 'ldem3d')

